<template>
  <section class="container">
    <div class="search">
      <v-text-field
        label="Search Order Id"
        v-model="orderid"
        filled
        rounded
        dense
        @keyup.enter="doc"
      ></v-text-field>
      <v-btn icon @click="doc" class="search-icon pa-10">
        <v-icon class="icon-btn">mdi-magnify</v-icon>
      </v-btn>
    </div>
    <div class="btn">
      <button class="export" v-if="pdf" @click="generatePDF">
        Export Your Order Pdf
      </button>
    </div>

    <table v-if="table" class="table">
      <tr>
        <th class="sno">S.No</th>
        <th class="pro-Name">Product Name</th>
        <th class="pro-Price">Price</th>
        <th class="pro-Quanity">Quanity</th>
        <th class="pro-TPrice">Total Price</th>
      </tr>
      <tr v-for="(orderdata, i) in first" :key="i">
        <td>{{ i + 1 }}</td>
        <td>{{ orderdata.ProductName }}</td>
        <td>₹ {{ orderdata.Price }}</td>
        <td>{{ orderdata.Quanity }}</td>
        <td>₹ {{ orderdata.TotalPrice }}</td>
      </tr>
      <tr>
        <td></td>
        <td class="G-total">Payment</td>
        <td class="G-total">{{ Pay.paid }}</td>
        <td class="G-total">Total</td>
        <td class="G-total">₹{{ finalPrice }}</td>
      </tr>
    </table>
  </section>
</template>
<script>
import { db } from "../firebase/db";
import jsPDF from "jspdf";
export default {
  data() {
    return {
      orderid: "",
      tableDetails: null,
      table: false,
      first: null,
      userDetails: null,
      finalPrice: null,
      pdf: false,
      date: null,
      grand: null,
      Pay: null,
      book: null,
      delivery: null,
    };
  },

  methods: {
    doc() {
      // debugger; // eslint-disable-line no-debugger

      db.collection("crackers")
        .doc(this.orderid)
        .get()
        .then((doc) => {
          if (doc.exists) {
            this.pdf = true;
            this.table = true;
            const document = doc.data();
            this.tableDetails = document.order;
            this.first = this.tableDetails.slice(1);
            this.userDetails = this.tableDetails[0];
            this.totalPrice();

            console.log(this.userDetails);
          } else {
            this.$toast.error("incorrect Orderid", { duration: "3000" });
          }
        })
        .catch((error) => {
          console.log("Error getting document:", error);
        });

      db.collection("payment")
        .doc(this.orderid)
        .get()
        .then((doc) => {
          if (doc.exists) {
            const document1 = doc.data();
            this.Pay = document1;
          } else {
            this.$toast.error("incorrect Orderid", { duration: "3000" });
          }
        })
        .catch((error) => {
          console.log("Error getting document:", error);
        });

      db.collection("Booking")
        .doc(this.orderid)
        .get()
        .then((doc) => {
          if (doc.exists) {
            const document1 = doc.data();
            this.book = document1;
          } else {
            this.$toast.error("incorrect Orderid", { duration: "3000" });
          }
        })
        .catch((error) => {
          console.log("Error getting document:", error);
        });
      db.collection("Delivery")
        .doc(this.orderid)
        .get()
        .then((doc) => {
          if (doc.exists) {
            const document1 = doc.data();
            this.delivery = document1;
          } else {
            this.$toast.error("incorrect Orderid", { duration: "3000" });
          }
        })
        .catch((error) => {
          console.log("Error getting document:", error);
        });
    },
    totalPrice() {
      var sum = 0;
      var id = this.first;
      for (var is = 0; is < id.length; is++) {
        if (isFinite(id[is].TotalPrice)) {
          sum += +id[is].TotalPrice;
        }
      }
      this.finalPrice = sum;
      this.grand = sum.toString();
    },
    generatePDF() {
      debugger; // eslint-disable-line no-debugger
      var doc = new jsPDF();
      var col = ["Product Name", "Price", "Quanity", "Total Price"];

      var rows = [];

      this.first.forEach((element) => {
        var temp = [
          element.ProductName,
          element.Price,
          element.Quanity,
          element.TotalPrice,
        ];

        rows.push(temp);
        console.log(rows);
      });
      doc.setFontSize(16).text("Universal Pyro", 80, 10.0);
      doc.setFontSize(16).text("Customer Name :", 0.5, 17.0);
      doc.setFontSize(16).text("Order Id :", 0.5, 23.0);
      doc.setFontSize(16).text("UPI ID :", 140, 17.0);
      doc.setFontSize(16).text("Date :", 140, 23.0);
      doc.setFontSize(16).text("xxxxxxxxxx@paytm", 160, 17.0);
      doc.setFontSize(12).text(this.userDetails.Name, 45, 17.0);
      doc.setFontSize(12).text(this.orderid, 30, 23.0);
      doc.setFontSize(12).text(this.date, 160, 23.0);
      doc.setLineWidth(0.1).line(0.1, 25, 250, 25);
      doc.autoTable(col, rows, { startY: 40 });
      let finalY = doc.lastAutoTable.finalY + 10;
      doc.setFontSize(16).text(this.grand, 175, finalY);
      doc.setFontSize(16).text("Grand total :", 140, finalY);
      doc.setFontSize(16).text("Payment :", 110, 260);
      doc
        .setTextColor(255, 0, 0)
        .setFontSize(20)
        .text(this.Pay.paid, 140, 260);
      doc
        .setFont("helvetica")
        .setFontSize(12)
        .text("***THANK YOU***", 110, 285, {
          align: "center",
          maxWidth: "100.5",
        });
      doc.setFontSize(16).text(this.book.book, 0.5, finalY);
      doc.setFontSize(16).text(this.delivery.delivery, 80, finalY);
      doc.setTextColor(150);
      // doc.text(50, doc.internal.pageSize.height - 30, "Watermark");
      doc.save(`${this.userDetails.Name}.pdf`);
    },
  },
  mounted() {
    var today = new Date();
    var dd = String(today.getDate()).padStart(2, "0");
    var mm = String(today.getMonth() + 1).padStart(2, "0"); //January is 0!
    var yyyy = today.getFullYear();

    today = mm + "/" + dd + "/" + yyyy;
    this.date = today;

    // this.OrderId = this.rndStr(15);
  },
};
</script>

<style scoped>
.container{
  padding-top: 50px;
}
.btn {
  display: flex;
  justify-content: center;
  align-items: center;
}
.export {
  background-color: #6c79e0;
  border: none;
  color: white;
  padding: 15px 32px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  margin: 4px 2px;
  cursor: pointer;
  -webkit-transition-duration: 0.4s;
  transition-duration: 0.4s;
}
.export:hover {
  box-shadow: 0 12px 16px 0 rgba(0, 0, 0, 0.24),
    0 17px 50px 0 rgba(0, 0, 0, 0.19);
  background-color: #6c79e0;
  color: #000;
}
.table {
  width: 800px;
  margin: auto;
}
table th {
  background-color: #6c79e0;
}
.sno {
  width: 40px;
}
.pro-Name {
  width: 300px;
}
.pro-Price {
  width: 150px;
}
.pro-Quanity {
  width: 150px;
}
.pro-TPrice {
  width: 150;
}
.G-total {
  font-size: 20px;
  font-weight: 600;
}
.search {
  width: 800px;
  display: flex;
  margin: auto;
}
.search .icon-btn {
  font-size: 50px;
}
.search-icon {
  margin: 8px 10px;
}
</style>
